//+------------------------------------------------------------------+
//|                                                     ZigzagFr.mq4 |
//|                               Copyright  2010, Vladimir Hlystov |
//|                                                cmillion@narod.ru |
//|Zigzag                                                 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Vladimir Hlystov"
#property link      "http://cmillion.narod.ru"
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Chocolate

extern int FractalBar = 10;  //        

double up,dn;
double Buffer[];
//+------------------------------------------------------------------+
int init()
  {
   Comment("Copyright  2010, Vladimir Hlystov","\n","http://cmillion.narod.ru");
   IndicatorBuffers(1);
   SetIndexStyle(0,DRAW_SECTION);
   SetIndexBuffer(0,Buffer);

   return(0);
  }
//+------------------------------------------------------------------+
int start()
{  
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0)  return(-1);
   if(counted_bars > 0)   counted_bars--;
   int limit = Bars - counted_bars;
   if(counted_bars==0) limit-=1+FractalBar;
      
   double fr;
   for(int i=limit; i>0; i--)
   {
      fr = Fractal(MODE_LOWER,i);
      if (fr!=0) Buffer[i]=fr;
      else
      {
         fr = Fractal(MODE_UPPER,i);
         if (fr!=0) Buffer[i]=fr;
         else Buffer[i]=EMPTY_VALUE;
      }
   }
   return(0);
}
//+------------------------------------------------------------------+
double Fractal(int tip,int bar)
{
   int i;
   if (tip==MODE_UPPER)
   {
      for (i=bar+1; i<bar+FractalBar; i++)
      {
         if (High[i]>High[bar]) return(0);
      }
      for (i=bar-1; i>bar-FractalBar; i--)
      {
         if (High[i]>High[bar]) return(0);
         if (i==0) return(0);
      }
      return(High[bar]);
   }
   if (tip==MODE_LOWER)
   {
      for (i=bar+1; i<bar+FractalBar; i++)
      {
         if (Low[i]<Low[bar]) return(0);
      }
      for (i=bar-1; i>bar-FractalBar; i--)
      {
         if (Low[i]<Low[bar]) return(0);
         if (i==0) return(0);
      }
      return(Low[bar]);
   }
}
//+------------------------------------------------------------------+

